#include <winsock2.h>
#include <windows.h>
#include "resource.h"
#include "iptools.h"
#include "strings.h"

BOOL CALLBACK DlgProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

HINSTANCE	hInstance;
HWND		hwndMain;
HWND		hInput;
HWND		hOutput;
MSG			msg;

void Execute()
{
	char* output    = NULL;
	char* newoutput = NULL;
	int   len;
	IPTools ipt;

	//get text from input
	char* domain = NULL;
	if(!(len=SendMessage(hInput, WM_GETTEXTLENGTH, 0, 0))) return;
	domain=new char[len+1];
	SendMessage(hInput, WM_GETTEXT, len+1, (LPARAM)domain);

	//get ip, hostname
	ULONG ip;
	char* ipstr, *host;
	ip =  ipt.GetHostIP(domain);
	ipstr = strnew(inet_ntoa(ipt.toina(ip)));
	host  = strnew(ipt.GetHostName(ip));

	//get whois info
	char* whois=ipt.GetWhois(host);

	output=strjoin(13, "Information on ", domain, ":\r\n",
		           "IP:   ", ipstr, "\r\n",
				   "Host: ", host,  "\r\n\r\n",
				   "Whois:\r\n",
				   whois, "\r\n\r\n",
				   "END OF TRANSMISSION");

	SendMessage(hOutput, WM_SETTEXT, 0, (LPARAM)output);

	if(domain) delete []domain;
	if(output) delete []output;
}

int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	hInstance=hInst;
	hwndMain=CreateDialog(hInstance, MAKEINTRESOURCE(IDD_MAIN), 0, DlgProc);
	hInput =GetDlgItem(hwndMain, IDC_INPUT);
	hOutput=GetDlgItem(hwndMain, IDC_OUTPUT);

	ShowWindow(hwndMain,iCmdShow);
	UpdateWindow(hwndMain);

	WORD	wVersionRequested;
	WSADATA	wsaData;

	wVersionRequested = MAKEWORD(2, 0);
	WSAStartup(wVersionRequested,&wsaData);

	while(GetMessage(&msg,NULL,0,0))
	{
		if(!IsDialogMessage(hwndMain, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return 0;
}

BOOL CALLBACK DlgProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case BN_CLICKED:
			switch(LOWORD(wParam))
			{
			case IDB_OK:
				Execute();
				break;
			}
		}
		break;
	case WM_SYSCOMMAND:
		switch(wParam)
		{
		case SC_CLOSE:
			WSACleanup();
			PostQuitMessage(0);
			break;
		}
	}
	return false;
};